<p align="center">
  <a href="https://velocity-x.web.app/" target="_blank">
    <h1>VelocityX</h1>
  </a>
</p>

[**VelocityX**](https://velocity-x.web.app/) is a 100% free Flutter open-source minimalist UI Framework built with <a href="https://flutter.dev/" target="_blank">Flutter SDK</a> to make Flutter development easier and more joyful than ever.

## Inspired from Tailwindcss and SwiftUI.

```dart
"Web".text.white.xl4.bold.center.makeCentered().box.roundedLg.red500.shadow2xl.make().whHalf(context).centered());
```

## Quick start

Read the [Getting started page](https://velocity-x.web.app/#/home)

## Contributing

VelocityX is **100% free** and **open source**. We encourage and support an active, healthy community that accepts contributions from the public &ndash; including you. There are a couple of ways in which you can contribute to the growing community of `VelocityX`.

- Pick up any issue marked with ["good first issue"](https://github.com/iampawan/velocityx/issues?q=is%3Aopen+is%3Aissue+label%3A%22good+first+issue%22)
- Fix a bug
- Write and improve some **documentation**. Documentation is very critical to us. We would appreciate help in adding multiple languages to our docs.
- If you are a developer, feel free to check out the source and submit pull requests.
- Dig into [**CONTRIBUTING.MD**](CONTRIBUTING.md), which covers submitting bugs, requesting new features, preparing your code for a pull request, etc.
- Please don't forget to **like**, **follow**, and **star our repo**!

## Documentation

[**Installation Guide**](https://velocity-x.web.app/#/home)

### Social Media

Twitter: <https://twitter.com/imthepk>

Facebook: <https://www.facebook.com/imthepk>

Linkedin: <https://www.linkedin.com/in/imthepk>

Instagram: <https://www.instagram.com/codepur_ka_superhero/>

### Note: VelocityX is not directly and/or indirectly associated/affiliated with Flutter or Google LLC.

## Copyright-and-license

Code and documentation Copyright 2020 [Pawan Kumar](https://pawan.live). Code released under the [Apache License]. Docs released under [Creative Commons](https://creativecommons.org/licenses/by/3.0/).
